module AdvancedDCL
  module Map
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("indexmj", Fixnum, "indexmj", "indexmjget", 3, 2)
      @param.init("indexmn", Fixnum, "indexmn", "indexmnget", 3, 2)
      @param.init("lgridmj", TrueClass, "umlset", "umlget", 0, 0)
      @param.init("lgridmn", TrueClass, "umlset", "umlget", 0, 0)
      @param.init("itypemj", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("itypemn", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("dgridmj", Float, "umrset", "umrget", 0, 0)
      @param.init("dgridmn", Float, "umrset", "umrget", 0, 0)
      @param.init("dgrplmj", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("dgrplmn", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("indexbnd", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("maxbnd", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("indexout", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("itypeout", Fixnum, "umiset", "umiget", 0, 0)
      @param.init("lwhint", TrueClass, "umlset", "umlget", 0, 0)
      @param.init("lglobe", TrueClass, "umlset", "umlget", 0, 0)
      
      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

    def settrf
      Fig.setumtrf
    end

#----------------------------------------------------------
    def draw(temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.setumtrf

      DCL.umpglb
      @backup.sync
      @temp_param.clear
    end

    def grid(temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.setumtrf

      DCL.umpgrd
      @backup.sync
      @temp_param.clear
    end

    def limb(temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.setumtrf

      DCL.umplim
      @backup.sync
      @temp_param.clear
    end

    def open(file, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.setumtrf

      DCL.umpmap(file)
      @backup.sync
      @temp_param.clear
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :settrf
    module_function :draw
    module_function :grid
    module_function :limb
    module_function :open
    
    param_init

#------------------- singleton methods ----------------------

    def @param.indexmj(index)
      DCL.umiset("indexmj", index)
    end

    def @temp_param.indexmj(index)
      DCL.umiset("indexmj", index)
    end
    
    def @backup.indexmj(index)
      DCL.umiset("indexmj", index)
    end

    def @param.indexmjget
      DCL.umiget("indexmj")
    end

    def @param.indexmn(index)
      DCL.umiset("indexmn", index)
    end

    def @temp_param.indexmn(index)
      DCL.umiset("indexmn", index)
    end

    def @backup.indexmn(index)
      DCL.umiset("indexmn", index)
    end

    def @param.indexmnget
      DCL.umiget("indexmn")
    end

#----------------------------------------------------------

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
